SystemOrganization addCategory: #BuscaMinas!

SimpleSwitchMorph subclass: #BMCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMCell methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 18:34'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!BMCell methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 18:14'!
mouseAction: aBlock
	^mouseAction := aBlock! !

SimpleSwitchMorph subclass: #BMPanel
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMPanel methodsFor: 'initialize' stamp: 'JamesErazo 5/18/2012 18:14'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 20@20.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
! !

!BMPanel methodsFor: 'access-ing' stamp: 'JamesErazo 5/18/2012 18:11'!
mouseAction: aBlock
	^mouseAction := aBlock! !

!BMPanel methodsFor: 'access-ing' stamp: 'JamesErazo 5/18/2012 18:11'!
mouseUp: anEvent
	mouseAction value
! !

BorderedMorph subclass: #BMGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BuscaMinas'!

!BMGame methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 17:18'!
cellsPerSide
	"retorna el numero de filas y colomnas del tablero del juego - constante"
	^20
! !

!BMGame methodsFor: 'initialization' stamp: 'JamesErazo 5/18/2012 18:34'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := BMCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (10@10 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].
! !

!BMGame methodsFor: 'game-logic' stamp: 'JamesErazo 5/18/2012 16:54'!
newCellAt: i at: j
	| c origin |
	c := BMCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j]
! !

!BMGame methodsFor: 'game-logic' stamp: 'JamesErazo 5/18/2012 16:55'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
! !
